BellmanFord< GR, LEN, TR >::SetOperationTraits< T > Struct Template Reference

- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members
BellmanFord< GR, LEN, TR >::SetOperationTraits< T > Struct Template Reference

## Detailed Description

### template<typename GR, typename LEN, typename TR>
template<class T>
struct lemon::BellmanFord< GR, LEN, TR >::SetOperationTraits< T >

Named parameter for setting `OperationTraits` type. For more information, see BellmanFordDefaultOperationTraits.

`#include <lemon/bellman_ford.h>`

Inheritance diagram for BellmanFord< GR, LEN, TR >::SetOperationTraits< T >:
[legend]

## Additional Inherited Members
Public Types inherited from BellmanFord< Digraph, LengthMap, SetOperationTraitsTraits< T > >
typedef SetOperationTraitsTraits< T > ::Digraph | Digraph
| The type of the underlying digraph.
typedef SetOperationTraitsTraits< T > ::LengthMap::Value | Value
| The type of the arc lengths.
typedef SetOperationTraitsTraits< T > ::LengthMap | LengthMap
| The type of the map that stores the arc lengths.
typedef SetOperationTraitsTraits< T > ::PredMap | PredMap
| The type of the map that stores the last arcs of the shortest paths.
typedef SetOperationTraitsTraits< T > ::DistMap | DistMap
| The type of the map that stores the distances of the nodes.
typedef PredMapPath< Digraph, PredMap > | Path
| The type of the paths.
typedef SetOperationTraitsTraits< T > ::OperationTraits | OperationTraits
| The operation traits class of the algorithm.
typedef SetOperationTraitsTraits< T > | Traits
| The traits class of the algorithm.
Public Member Functions inherited from BellmanFord< Digraph, LengthMap, SetOperationTraitsTraits< T > >
| BellmanFord (const Digraph &g, const LengthMap &length)
| Constructor. More...
| ~BellmanFord ()
| Destructor.
BellmanFord & | lengthMap (const LengthMap &map)
| Sets the length map. More...
BellmanFord & | predMap (PredMap &map)
| Sets the map that stores the predecessor arcs. More...
BellmanFord & | distMap (DistMap &map)
| Sets the map that stores the distances of the nodes. More...
const PredMap & | predMap () const
| Returns a const reference to the node map that stores the predecessor arcs. More...
const DistMap & | distMap () const
| Returns a const reference to the node map that stores the distances of the nodes. More...
Path | path (Node t) const
| The shortest path to the given node. More...
Value | dist (Node v) const
| The distance of the given node from the root(s). More...
Arc | predArc (Node v) const
| Returns the 'previous arc' of the shortest path tree for the given node. More...
Node | predNode (Node v) const
| Returns the 'previous node' of the shortest path tree for the given node. More...
bool | reached (Node v) const
| Checks if a node is reached from the root(s). More...
lemon::Path< Digraph > | negativeCycle () const
| Gives back a negative cycle. More...
void | init (const Value value=OperationTraits::infinity())
| Initializes the internal data structures. More...
void | addSource (Node source, Value dst=OperationTraits::zero())
| Adds a new source node. More...
bool | processNextRound ()
| Executes one round from the Bellman-Ford algorithm. More...
bool | processNextWeakRound ()
| Executes one weak round from the Bellman-Ford algorithm. More...
void | start ()
| Executes the algorithm. More...
bool | checkedStart ()
| Executes the algorithm and checks the negative cycles. More...
void | limitedStart (int num)
| Executes the algorithm with arc number limit. More...
void | run (Node s)
| Runs the algorithm from the given root node. More...
void | run (Node s, int num)
| Runs the algorithm from the given root node with arc number limit. More...